#ifndef _XsmKnob_h
#define _XsmKnob_h

/* always include Xm.h */
#include <Xm/Xm.h>

/* add extern for C++ applications */
#ifdef __cplusplus
extern "C" {
#endif

/* Resource Names */

#define XsmNvalueChangedCallback	"valueChangedCallback"
#define XsmNindicatorColor		"indicatorColor"
#define XsmNmarginWidth			"marginWidth"
#define XsmNmarginHeight		"marginHeight"
#define XsmNknobMargin			"knobMargin"
#define XsmNknobColor			"knobColor"
#define XsmNmaxValue			"maxValue"
#define XsmNminValue			"minValue"
#define XsmNturnDelay			"turnDelay"
#define XsmNvalue			"value"

/* Resource Class Names */

#define XsmCValueChangedCallback	"ValueChangedCallback"
#define XsmCIndicatorColor		"IndicatorColor"
#define XsmCMarginWidth			"MarginWidth"
#define XsmCMarginHeight		"MarginHeight"
#define XsmCKnobMargin			"KnobMargin"
#define XsmCMaxValue			"MaxValue"
#define XsmCMinValue			"MinValue"
#define XsmCTurnDelay			"TurnDelay"
#define XsmCValue			"Value"

/* Callback Structs */
typedef struct
{
   int reason;
   XEvent * event;
   int value;
} XsmKnobCallbackStruct;

/* Callback reason for the above callback */
#define XsmCR_VALUE_CHANGED	0


/* extern the widget class for applications that use XtCreateWidget() */
externalref WidgetClass       xsmKnobWidgetClass;

/*
 * To allow applications to use tight type checking, define
 * structures for the widget class and instance pointers
 * specific to this class of widget.
 */
typedef struct _XsmKnobClassRec * XsmKnobWidgetClass;
typedef struct _XsmKnobRec * XsmKnobWidget;



/********    Public Function Declarations    ********/

/* Declare the function that can be used by the application developer. */

extern Widget XsmCreateKnob( 
                        Widget parent,
                        char *name,
                        ArgList arglist,
                        Cardinal argcount) ;
extern int XsmGetKnobValue( 
                        Widget w) ;
extern void XsmSetKnobValue( 
                        Widget w,
                        int value) ;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XsmKnob_h */
/* DON'T ADD STUFF AFTER THIS #endif */
